﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class ArmoredCarCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject x, IDrawningObject y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xCar = x as DrawningObjectArmCar;
            var yCar = y as DrawningObjectArmCar;
            if (xCar == null && yCar == null)
            {
                return 0;
            }
            if (xCar == null && yCar != null)
            {
                return 1;
            }
            if (xCar != null && yCar == null)
            {
                return -1;
            }
            string xCarColor = xCar.GetArmoredCar.ArmoredCar.BodyColor.Name;
            string yCarColor = yCar.GetArmoredCar.ArmoredCar.BodyColor.Name;
            if (xCarColor != yCarColor)
            {             
                return xCarColor.CompareTo(yCarColor);
            }

            if (xCar.GetArmoredCar.ArmoredCar is EntityTank xTank && yCar.GetArmoredCar.ArmoredCar is EntityTank yTank) 
            {
                string xCarDopColor = xTank.DopColor.Name;
                string yCarDopColor = yTank.DopColor.Name;
                if (xCarDopColor != yCarDopColor)
                {
                    return xCarDopColor.CompareTo(yCarDopColor);
                }
            }

            var speedCompare = xCar.GetArmoredCar.ArmoredCar.Speed.CompareTo(yCar.GetArmoredCar.ArmoredCar.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xCar.GetArmoredCar.ArmoredCar.Weight.CompareTo(yCar.GetArmoredCar.ArmoredCar.Weight);
        }
    }
}
