﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class ArmoredCarCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject x, IDrawningObject y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xCar = x as DrawningObjectArmCar;
            var yCar = y as DrawningObjectArmCar;
            if (xCar == null && yCar == null)
            {
                return 0;
            }
            if (xCar == null && yCar != null)
            {
                return 1;
            }
            if (xCar != null && yCar == null)
            {
                return -1;
            }
            if (xCar.GetArmoredCar.GetType().Name != yCar.GetArmoredCar.GetType().Name)
            {
                if (xCar.GetArmoredCar.GetType().Name == "DrawningArmoredCar")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xCar.GetArmoredCar.ArmoredCar.Speed.CompareTo(yCar.GetArmoredCar.ArmoredCar.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xCar.GetArmoredCar.ArmoredCar.Weight.CompareTo(yCar.GetArmoredCar.ArmoredCar.Weight);
        }
    }
}
